# -*- coding: utf-8 -*-
##############################################################################
#
#    OpenERP, Open Source Management Solution    
#    Copyright (C) 2011 Juanjo Abenza. All Rights Reserved
#    d$
#
#    This program is free software: you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation, either version 3 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program.  If not, see <http://www.gnu.org/licenses/>.
#
##############################################################################

from osv import osv, fields

class link_connection_contact(osv.osv):
    ''' Object to link OpenERP contact with Moodle contact'''

    _name = 'link.connection.contact'

    _columns = {
        'connection':fields.many2one('training.moodle.connection',
                                     'Connection', readonly=True, select=True),
        'contact_id': fields.many2one('res.partner.contact', 'Contact',
                                readonly=True, select=True, ondelete='cascade'),
        'id_moodle': fields.integer('Moodle ID', size=35, readonly=True),
        'data': fields.date('Record date', readonly=True),
    }

link_connection_contact()
