# -*- coding: utf-8 -*-
##############################################################################
#
#    OpenERP, Open Source Management Solution    
#    Copyright (C) 2011 Juanjo Abenza. All Rights Reserved
#    d$
#
#    This program is free software: you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation, either version 3 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program.  If not, see <http://www.gnu.org/licenses/>.
#
##############################################################################

from osv import osv, fields


class link_connection_course(osv.osv):
    ''' Links offer or course with them Moodle id'''
    _name = 'link.connection.course'

    _columns = {
        'connection':fields.many2one('training.moodle.connection', 'Connection',
                                     readonly=True, select=True),
        'offer_id': fields.many2one('training.offer', 'Offer', readonly=True,
                                    select=True, ondelete='cascade'),
        'course_id': fields.many2one('training.course', 'Course', readonly=True,
                                     select=True, ondelete='cascade'),
        'id_moodle': fields.integer('Moodle ID', size=35, readonly=True),
        'data': fields.date('Record date', readonly=True),
    }

    def name_get(self, cr, uid, ids, context=None):
        '''# Generate a name to show in the field mapping_created of the 
            training.moodle.course model '''
        if not ids:
            return []
        res = []
        for r in self.read(cr, uid, ids, ['connection', 'id_moodle'], context):
            res.append((r['id'], '%s-%s' % (r['connection'], 'id_moodle')))
        return res

link_connection_course()
