# -*- coding: utf-8 -*-
##############################################################################
#
#    OpenERP, Open Source Management Solution    
#    Copyright (C) 2011 Juanjo Abenza. All Rights Reserved
#    d$
#
#    This program is free software: you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation, either version 3 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program.  If not, see <http://www.gnu.org/licenses/>.
#
##############################################################################

from osv import osv, fields

class link_connection_subscription(osv.osv):
    #Links subscription lines, participants, offers and a connexion between others data

	_name = 'link.connection.subscription'

	_columns = {
		'connection':fields.many2one('training.moodle.connection', 'Connection',
                                     readonly=True, select=True),
		'id_subscription_a': fields.many2one('training.subscription',
                                            'Subscription', select=True,
                                            ondelete='cascade', readonly=True),
		'id_participant': fields.many2one('res.partner.job', 'Participant',
                            select=True, ondelete='cascade', readonly=True),
		'off_subscrip_o': fields.many2one('training.offer', 'Offer',
                            select=True, readonly=True, ondelete='cascade'),
		'id_subscription_line_a': fields.many2one('training.subscription.line',
                                            'Subscription Line', select=True,
                                            ondelete='cascade', readonly=True),
		'session_id': fields.many2one('training.session', 'Session',
                                      readonly=True, select=True),
		'data': fields.date('Record date', readonly=True),
		'moodle_import_subs': fields.many2one('imports.moodle.subscriptions',
                                            'Subscription Mapp', select=True, readonly=True, invisible=True),
    }

	def name_get(self, cr, uid, ids, context):
		if not ids:
			return []
		res = []
		for r in self.read(cr, uid, ids, ['connection', 'session_id'], context):
			res.append((r['id'], '%s-%s' % (r['connection'], 'session_id')))
		return res

link_connection_subscription()
