# -*- coding: utf-8 -*-
##############################################################################
#
#    OpenERP, Open Source Management Solution
#    Copyright (C) 2011 Juanjo Abenza. All Rights Reserved
#    d$
#
#    This program is free software: you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation, either version 3 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program.  If not, see <http://www.gnu.org/licenses/>.
#
##############################################################################

from osv import osv, fields
from conection import mdl_connection

class res_partner_contact(osv.osv):
    '''Update Moodle data from OpenERP contacts'''

    _inherit = 'res.partner.contact'
    _columns = {
        'moodle_mapping_ids': fields.one2many('link.connection.contact','contact_id','Moodle mappings'),
    }

    def act_moodle_user(self, cr, uid, ids, context=None):
        if context is None:
            context = {}
        mdl = mdl_connection()

        partner_contact_obj = self.browse(cr, uid, ids[0], context)
        first_name = partner_contact_obj.first_name
        name = partner_contact_obj.name
        email = partner_contact_obj.email
        for moodle_mapping in partner_contact_obj.moodle_mapping_ids:
            # contact to update
            conect = moodle_mapping.connection
            url = conect.url
            token = conect.token
            id_user_mod = moodle_mapping.id_moodle
#            print "Actualitzant l'usuari " + str(cntx) + " a la conexio: " + str(name_conect)
            # Make inheritance to save the id of the contact, to ensure to make it the same user when upgrading
            function = 'moodle_user_update_users&users[0][id]=' + str(id_user_mod) + '&users[0][username]=' + first_name + '&users[0][firstname]=' + first_name + '&users[0][lastname]=' + name + '&users[0][email]=' + email

            response = mdl.conn_rest(url, token, function)
#            print response
        return 0

res_partner_contact()
