# -*- encoding: utf-8 -*-
##############################################################################
#
#    OpenERP, Open Source Management Solution    
#    Copyright (C) 2011 Juanjo Abenza. All Rights Reserved
#    d$
#
#    This program is free software: you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation, either version 3 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program.  If not, see <http://www.gnu.org/licenses/>.
#
##############################################################################

from osv import osv, fields
from xml.dom.minidom import parseString
import random
import string
from time import strftime
from conection import mdl_connection
import netsvc

# Wizard encarregat de crear els contactes d'OpenERP com a usuaris a Moodle

class export_users_wizard(osv.osv_memory):
    
    _name = 'export.users.wizard'
    _columns = {
        'participation_id' : fields.many2one('training.moodle.connection', 'Connection', required=True, select=True),
    }

    def close_cb(self, cr, uid, ids, context=None):
        return {'type' : 'ir.actions.act_window_close'}

    def apply_cb(self, cr, uid, ids, context=None):

        if context is None:
            context = {}

        mdl = mdl_connection()
        timestamp = strftime('[%Y-%m-%d %H:%M:%S] ')

        #Agafa el valor del registre connection sel·leccionat al wizard
        # ids is already defined in call parameters of the function
        conx = self.browse(cr, uid, ids, context)
        url = conx[0].participation_id.url
        token = conx[0].participation_id.token
        id_con = conx[0].participation_id.id
        userID = 0 # store moodleid returned in response
        # nomes recupera els id's dels objectes
        contact_ids = self.pool.get('res.partner.contact').search(cr, uid, [('email','!=', ""), ('first_name','!=', "")])
        # recupera tots els camps dels id's idexists
        contacts = self.pool.get('res.partner.contact').browse(cr, uid, contact_ids, context)

        for contact in contacts:
            # randomly create password        
            chars = string.letters + string.digits
            password = ''.join([random.choice(chars) for i in range(8)])
            username = contact.first_name
            firstname = contact.first_name
            lastname = contact.name
            email = contact.email
            # Recupera el id del contacte actual
            contact_id = contact.id
            
            ## Recupera el id de la conexio
            function = 'moodle_user_create_users&users[0][username]=' + username+ '&users[0][password]=' + password + '&users[0][firstname]=' + firstname+ '&users[0][lastname]=' + lastname + '&users[0][email]=' + email + '&users[0][mailformat]=1'

            # En openERP nomes es obligatori el lastname. Per comunicacio amb Moodle obligatori email
            if email:
                response = mdl.conn_rest(url, token, function)
                if response.find('VALUE')>-1: # si en "response" es troba VALUE entra al if
                    dom = parseString(response)
                    i = 0
                    for node in dom.getElementsByTagName('VALUE'):
                        i = i + 1
                        # get first value (user ID)
                        if i==1:
                            valueResponse = node.toxml()
                            userID = valueResponse.replace('<VALUE>','').replace('</VALUE>','')
                        # get second value (username)
                        elif i==2:
                            valueResponse = node.toxml()
                            username = valueResponse.replace('<VALUE>','').replace('</VALUE>','')
                    last = timestamp + 'New Moodle user (' + username + ') created sucessfully with ID: ' + userID + '.'
                    print last
                    # LINK CONNECTION Guardo informació de la conexió als registres creats de link.connection.contact
                    # Guardar també la data
                    request = self.pool.get('link.connection.contact')
                    request.create(cr, uid, {
                                            'connection' : id_con,
                                            'contact_id': contact_id,
                                            'id_moodle': userID,
                                            'data': timestamp
                    })
                # si response contiene "invalid_parameter_exception" quiere decir que el usuario de Moodle ya existe
                elif response.find('invalid_parameter_exception')>-1: # user exists error
                    #netsvc.Logger().notifyChannel('training_moodle', netsvc.LOG_ERROR, "Error: user already exists in Moodle!")
                    last = 'User already exists in Moodle'
                    print last 
                else: # an error has occured
                    #netsvc.Logger().notifyChannel('training_moodle', netsvc.LOG_ERROR, "Unknown error. Moodle server says: %s" % response)
                    last = 'Unknown error.'
                    print last
            else:
                #netsvc.Logger().notifyChannel('training_moodle', netsvc.LOG_ERROR, "Error in the user %s: missing user information in the fields" % username)
                last = 'Error in the user ' + username + ': missing user information in the fields'
                print last
        return {'type' : 'ir.actions.act_window_close'}

export_users_wizard()
