# -*- encoding: utf-8 -*-
##############################################################################
#
#    OpenERP, Open Source Management Solution    
#    Copyright (C) 2011 Juanjo Abenza. All Rights Reserved
#    d$
#
#    This program is free software: you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation, either version 3 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program.  If not, see <http://www.gnu.org/licenses/>.
#
##############################################################################

from osv import osv, fields
from xml.dom.minidom import parseString #, parse
from time import strftime
from conection import mdl_connection
import netsvc


class training_import_courses_wizard(osv.osv_memory):
    '''
        This wizard make petitions to get Moodle courses and save them in 'Moodle course Mapping'
    '''

    _name = 'training.import.courses.wizard'
    _columns = {
        'participation_id' : fields.many2one('training.moodle.connection', 'Connection', required=True, select=True),
    }

    def close_cb(self, cr, uid, ids, context=None):
        return {'type' : 'ir.actions.act_window_close'}

    def apply_cb(self, cr, uid, ids, context=None):

        mdl = mdl_connection()

        if context is None:
            context = {}
        timestamp = strftime('[%Y-%m-%d] ')

        training_moodle_course_obj = self.pool.get('training.moodle.course')
        # It takes the connection value of the record selected in wizard
        ids = self.search(cr, uid, [])
        conx = self.browse(cr, uid, ids, context)
        url = conx[0].participation_id.url
        token = conx[0].participation_id.token
        id_conx = conx[0].participation_id.id
        # Web service function responsible of obtaining the Moodle courses
        function = 'moodle_course_get_courses'
        response = mdl.conn_rest(url, token, function)
        # Extract information from xml response to create records in OpenERP
        if response.find('VALUE') > -1:
            dom = parseString(response)
            for course_inf in dom.getElementsByTagName('KEY'):
                a = course_inf.attributes["name"]
                nombreES = a.value
                if nombreES == "id":
#                    if nombreES != "": 
                        # if nombreEs == "id" 
                    try:
                        valueResponse = course_inf.toxml()
                        xmlData = valueResponse.replace('<VALUE>', '').replace('</VALUE>', '')
                        xmlData = xmlData.replace('<KEY name="id">', '').replace('</KEY>', '')
                        # If the user already exists as a Moodle OpenERP contact skip it.
                        id_moodle_link_c = training_moodle_course_obj.search(cr, uid, [('moodleid', '=', xmlData), ('id_connection', '=', id_conx)])
                        if id_moodle_link_c == []:
                            idreg = training_moodle_course_obj.create(cr, uid, {'moodleid':xmlData, 'data': timestamp})
                        else:
                            #netsvc.Logger().notifyChannel('training_moodle', netsvc.LOG_WARNING, "User already exists as a Moodle OpenERP contact")
                            print "Course already exists as a Moodle OpenERP course"
                    except NameError:
                        #netsvc.Logger().notifyChannel('training_moodle', netsvc.LOG_ERROR, "Unknown error")
#                       # an error has occurred
                        last = 'Unknown error. Moodle server says: id'#+ response
                        print last    
#                    else:
#                        netsvc.Logger().notifyChannel('training_moodle', netsvc.LOG_WARNING, "No number id")
#                        print "No number id"
                elif nombreES == "fullname":
#                    if nombreES != "": # if nombreEs == "fullname"
                    try:
                        valueResponse = course_inf.toxml()
                        xmlData = valueResponse.replace('<VALUE>', '').replace('</VALUE>', '')
                        xmlData = xmlData.replace('<KEY name="fullname">', '').replace('</KEY>', '').strip("\n")
                        training_moodle_course_obj.write(cr, uid, idreg, {
                                                'name':xmlData,
                                                'id_connection':id_conx
                                                })
                    except NameError:
                        #netsvc.Logger().notifyChannel('training_moodle', netsvc.LOG_ERROR, "Unknown error")
                    # An error has occurred
                        last = 'Unknown error. Moodle server says: fullname' #+ response
                        print last
                elif nombreES == "shortname":
#                    if nombreES != "": # if nombreEs == "shortname"
                    try:
                        valueResponse = course_inf.toxml()
                        xmlData = valueResponse.replace('<VALUE>', '').replace('</VALUE>', '')
                        xmlData = xmlData.replace('<KEY name="shortname">', '').replace('</KEY>', '').strip("\n")
                        training_moodle_course_obj.write(cr, uid, idreg, {'short_name':xmlData})
                    except NameError:
                        #netsvc.Logger().notifyChannel('training_moodle', netsvc.LOG_ERROR, "Unknown error")
                    # An error has occurred
                        last = 'Unknown error. Moodle server says: shortname'#+ response
                        print last
                elif nombreES == "numsections": #weeks
                    if nombreES != "": # if nombreEs == "numsections"
                        try:
                            valueResponse = course_inf.toxml()
                            xmlData = valueResponse.replace('<VALUE>', '').replace('</VALUE>', '')
                            xmlData = xmlData.replace('<KEY name="numsections">', '').replace('</KEY>', '')
                            tra = training_moodle_course_obj
                            tra.write(cr, uid, idreg, {'weeks':xmlData})
                        except NameError:
                            #netsvc.Logger().notifyChannel('training_moodle', netsvc.LOG_ERROR, "Unknown error")
                        # An error has occurred
                            last = 'Unknown error. Moodle server says: numsections' #+ response
                            print last
                #else:
                    #netsvc.Logger().notifyChannel('training_moodle', netsvc.LOG_WARNING, "nombreES incorrect")

            return {'type' : 'ir.actions.act_window_close'}

training_import_courses_wizard()
